###########################################################################
# $Id: StorageHF.p,v 1.9 2007-12-04 09:09:39 misha Exp $
# implementation for store data into hashfile
#
# limitation:
#	- the size of one record (key + value) can't be more then 8000 bytes


@CLASS
StorageHF


@USE
StorageStr.p


@BASE
StorageStr



###########################################################################
@auto[]
$sClassName[StorageHF]

$hDefault[
	$.uExpires(0)
	$.sDir[/../$MAIN:DATA_DIR/$sClassName]
]

$hStorage[^hash::create[]]
#end @auto[]



###########################################################################
@create[sStorageName;hParam]
^BASE:create[$sStorageName;$hParam]

$iMaxDataLenght(7999)
#end @create[]



###########################################################################
# private

@_init[hParam]
$self.sDataDir[^if(def $hParam.sDataDir){$hParam.sDataDir}{$hDefault.sDir}]
$result[]


@_open[][sFileName]
^if(!def $hfStorage){
	$sFileName[$self.sDataDir/$self.sStorageName]
	^if(!def $hStorage.$sFileName){
		$hStorage.[$sFileName][^hashfile::open[$sFileName]]
	}
	$hfStorage[$hStorage.$sFileName]
}
$result[]


@_get[sKey]
$result[^self._unpack[$hfStorage.$sKey]]


@_set[sKey;hValue][sValue]
^self._check_size[$sKey;$hValue]
$hfStorage.[$sKey][
	$.value[^self._pack[$hValue]]
	^if($hValue.uExpires is "date"){
		$.expires[$hValue.uExpires]
	}{
		$.expires(^if(def $hValue.uExpires){$hValue.uExpires}{$hDefault.uExpires})
	}
]
$result[]


@_delete[sKey]
^hfStorage.delete[$sKey]
$result[]


@_release[]
^try{
	^hfStorage.release[]
}{
	$exception.handled(true)
}
$result[]


@_cleanup[]
^try{
	^hfStorage.cleanup[]
}{
	$exception.handled(true)
	^hfStorage.foreach[;]{}
}
$result[]

